'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connect = exports.toJS = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var toJS = exports.toJS = function toJS(WrappedComponent) {
  return function (wrappedComponentProps) {
    var KEY = 0;
    var VALUE = 1;

    var propsJS = Object.entries(wrappedComponentProps).reduce(function (newProps, wrappedComponentProp) {
      newProps[wrappedComponentProp[KEY]] = _immutable.Iterable.isIterable(wrappedComponentProp[VALUE]) ? wrappedComponentProp[VALUE].toJS() : wrappedComponentProp[VALUE];
      return newProps;
    }, {});

    return _react2.default.createElement(WrappedComponent, propsJS);
  };
};

var connect = exports.connect = function connect() {
  for (var _len = arguments.length, vargs = Array(_len), _key = 0; _key < _len; _key++) {
    vargs[_key] = arguments[_key];
  }

  return function (reactComponent) {
    return _reactRedux.connect.apply(undefined, vargs)(toJS(reactComponent));
  };
};

exports.default = {
  connect: connect,
  toJS: toJS
};